#include <stdio.h>
#include <stdlib.h>

typedef struct cvor CVOR; 
typedef struct cvor* PCVOR;

struct cvor{
	int broj;
	PCVOR sledeci;
};

void ubaciNaPocetak(PCVOR* glava,int broj){
	PCVOR novi;
	novi=malloc(sizeof(CVOR));
	novi->broj=broj;
	novi->sledeci=NULL;
	if (*glava==NULL) {
		//lista je prazna
		*glava=novi;
	}
	else {
		novi->sledeci=*glava;
		*glava=novi;
	}

}

void prikaziListu(PCVOR glava){
	PCVOR tek=glava;
	printf("\n");
	while(tek!=NULL){
		printf("%3d",tek->broj);
		tek=tek->sledeci;
	}

}

int brojElemenata(PCVOR glava){
	PCVOR tek=glava;
	int brojac=0;
	
	while(tek!=NULL){
		brojac++;
		tek=tek->sledeci;
	}
	return brojac;
}

void ubaciNaKraj(PCVOR* glava,int broj){
	PCVOR novi;
	PCVOR tek=*glava;

	novi=malloc(sizeof(CVOR));
	novi->broj=broj;
	novi->sledeci=NULL;

	if (*glava==NULL) *glava=novi;
	else{
		while(tek->sledeci!=NULL){
			tek=tek->sledeci;
		}
		tek->sledeci=novi;
	}
}

void izbaciPrviElement(PCVOR* glava){
	PCVOR tek;

	if (*glava==NULL) return;
	if ((*glava)->sledeci==NULL){
		//brisem jedan jedini element u listi
		tek=*glava;
		*glava=NULL;
		free(tek);
	}
	else {
		//ima jos elemenata u listi
		tek=*glava;
		*glava=(*glava)->sledeci;
		free(tek);
	}

}

int main(void){
	PCVOR glava=NULL;
	int broj;

	ubaciNaPocetak(&glava,4);
	ubaciNaPocetak(&glava,6);
	ubaciNaPocetak(&glava,8);

	prikaziListu(glava);
	broj=brojElemenata(glava);
	printf("\nBroj elemenata je %3d\n",broj);

	ubaciNaKraj(&glava,10);
	ubaciNaKraj(&glava,12);
	prikaziListu(glava);

	izbaciPrviElement(&glava);
	prikaziListu(glava);
	izbaciPrviElement(&glava);
	prikaziListu(glava);
	izbaciPrviElement(&glava);
	prikaziListu(glava);

	return 0;
}